From 46638951e793b27363f1733228b0ea46e57b84b5 Mon Sep 17 00:00:00 2001
From: Chris Ahrendt <celticht32@aol.com>
Date: Thu, 13 Nov 2008 23:44:39 -0500
Subject: [PATCH] This is the Fix for an exception which occurs in dsurface.c bexause the initization fails for the surfaces.

---
 dlls/ddraw/tests/dsurface.c |   47 +++++++++++++++++++++++++++++++++++++++++-
 1 files changed, 45 insertions(+), 2 deletions(-)

diff --git a/dlls/ddraw/tests/dsurface.c b/dlls/ddraw/tests/dsurface.c
index d4626ad..a70ea9f 100644
--- a/dlls/ddraw/tests/dsurface.c
+++ b/dlls/ddraw/tests/dsurface.c
@@ -1136,6 +1136,10 @@ static void AttachmentTest7(void)
     ddsd.dwBackBufferCount = 2;
     hr = IDirectDraw7_CreateSurface(dd7, &ddsd, &surface1, NULL);
     ok(hr==DD_OK,"CreateSurface returned: %x\n",hr);
+    if (FAILED(hr)) {
+       skip("Can't create cubemap surface1\n");
+       goto err;
+      }
 
     num = 0;
     IDirectDrawSurface7_EnumAttachedSurfaces(surface1, &num, SurfaceCounter);
@@ -1163,6 +1167,10 @@ static void AttachmentTest7(void)
     ddsd.ddsCaps.dwCaps = DDSCAPS_PRIMARYSURFACE;
     hr = IDirectDraw7_CreateSurface(dd7, &ddsd, &surface1, NULL);
     ok(hr==DD_OK,"CreateSurface returned: %x\n",hr);
+    if (FAILED(hr)) {
+       skip("Can't create cubemap surface1\n");
+       goto err;
+      }
 
     memset(&ddsd, 0, sizeof(ddsd));
     ddsd.dwSize = sizeof(ddsd);
@@ -1172,6 +1180,10 @@ static void AttachmentTest7(void)
     ddsd.dwHeight = GetSystemMetrics(SM_CYSCREEN);
     hr = IDirectDraw7_CreateSurface(dd7, &ddsd, &surface2, NULL);
     ok(hr==DD_OK,"CreateSurface returned: %x\n",hr);
+    if (FAILED(hr)) {
+       skip("Can't create cubemap surface2\n");
+       goto err1;
+      }
 
     memset(&ddsd, 0, sizeof(ddsd));
     ddsd.dwSize = sizeof(ddsd);
@@ -1181,6 +1193,10 @@ static void AttachmentTest7(void)
     ddsd.dwHeight = GetSystemMetrics(SM_CYSCREEN);
     hr = IDirectDraw7_CreateSurface(dd7, &ddsd, &surface3, NULL);
     ok(hr==DD_OK,"CreateSurface returned: %x\n",hr);
+    if (FAILED(hr)) {
+       skip("Can't create cubemap surface3\n");
+       goto err2;
+      }
 
     /* This one has a different size */
     memset(&ddsd, 0, sizeof(ddsd));
@@ -1191,6 +1207,10 @@ static void AttachmentTest7(void)
     ddsd.dwHeight = 128;
     hr = IDirectDraw7_CreateSurface(dd7, &ddsd, &surface4, NULL);
     ok(hr==DD_OK,"CreateSurface returned: %x\n",hr);
+    if (FAILED(hr)) {
+       skip("Can't create cubemap surface4\n");
+       goto err3;
+      }
 
     hr = IDirectDrawSurface7_AddAttachedSurface(surface1, surface2);
     ok(hr == DDERR_CANNOTATTACHSURFACE, "Attaching an offscreen plain surface to a front buffer returned %08x\n", hr);
@@ -1204,10 +1224,14 @@ static void AttachmentTest7(void)
     ok(hr == DDERR_CANNOTATTACHSURFACE, "Attaching a front buffer to an offscreen plain surface of different size returned %08x\n", hr);
 
     IDirectDrawSurface7_Release(surface4);
+err3:
     IDirectDrawSurface7_Release(surface3);
+err2:
     IDirectDrawSurface7_Release(surface2);
+err1:
     IDirectDrawSurface7_Release(surface1);
 
+err:
     hr =IDirectDraw7_SetCooperativeLevel(dd7, NULL, DDSCL_NORMAL);
     ok(hr == DD_OK, "SetCooperativeLevel returned %08x\n", hr);
     IDirectDraw7_Release(dd7);
@@ -1344,7 +1368,11 @@ static void AttachmentTest(void)
     ddsd.ddsCaps.dwCaps = DDSCAPS_PRIMARYSURFACE;
     hr = IDirectDraw_CreateSurface(lpDD, &ddsd, &surface1, NULL);
     ok(hr==DD_OK,"CreateSurface returned: %x\n",hr);
-
+    if (FAILED(hr)) {
+       skip("Can't create cubemap surface1\n");
+       goto err;
+      }
+      
     memset(&ddsd, 0, sizeof(ddsd));
     ddsd.dwSize = sizeof(ddsd);
     ddsd.dwFlags = DDSD_CAPS | DDSD_WIDTH | DDSD_HEIGHT;
@@ -1353,6 +1381,10 @@ static void AttachmentTest(void)
     ddsd.dwHeight = GetSystemMetrics(SM_CYSCREEN);
     hr = IDirectDraw_CreateSurface(lpDD, &ddsd, &surface2, NULL);
     ok(hr==DD_OK,"CreateSurface returned: %x\n",hr);
+    if (FAILED(hr)) {
+       skip("Can't create cubemap surface2\n");
+       goto err1;
+      }
 
     memset(&ddsd, 0, sizeof(ddsd));
     ddsd.dwSize = sizeof(ddsd);
@@ -1362,6 +1394,10 @@ static void AttachmentTest(void)
     ddsd.dwHeight = GetSystemMetrics(SM_CYSCREEN);
     hr = IDirectDraw_CreateSurface(lpDD, &ddsd, &surface3, NULL);
     ok(hr==DD_OK,"CreateSurface returned: %x\n",hr);
+    if (FAILED(hr)) {
+       skip("Can't create cubemap surface3\n");
+       goto err2;
+      }
 
     /* This one has a different size */
     memset(&ddsd, 0, sizeof(ddsd));
@@ -1372,6 +1408,10 @@ static void AttachmentTest(void)
     ddsd.dwHeight = 128;
     hr = IDirectDraw_CreateSurface(lpDD, &ddsd, &surface4, NULL);
     ok(hr==DD_OK,"CreateSurface returned: %x\n",hr);
+    if (FAILED(hr)) {
+       skip("Can't create cubemap surface4\n");
+       goto err3;
+      }
 
     hr = IDirectDrawSurface_AddAttachedSurface(surface1, surface2);
     ok(hr == DD_OK, "Attaching an offscreen plain surface to a front buffer returned %08x\n", hr);
@@ -1401,10 +1441,13 @@ static void AttachmentTest(void)
     ok(hr == DDERR_CANNOTATTACHSURFACE, "Attaching a front buffer to an offscreen plain surface of different size returned %08x\n", hr);
 
     IDirectDrawSurface_Release(surface4);
+err3:
     IDirectDrawSurface_Release(surface3);
+err2:
     IDirectDrawSurface_Release(surface2);
+err1:
     IDirectDrawSurface_Release(surface1);
-
+err:
     hr =IDirectDraw_SetCooperativeLevel(lpDD, NULL, DDSCL_NORMAL);
     ok(hr == DD_OK, "SetCooperativeLevel returned %08x\n", hr);
 
-- 
1.5.5.1

